import { EventEmitter } from "@angular/core";
import { FormGroup } from "@angular/forms";
import { BaseFilter } from "../shared/base.filter";
import * as i0 from "@angular/core";
export declare abstract class BaseFilterComponent {
    filter: BaseFilter;
    myForm: FormGroup;
    filterOrders: FilterOrder[];
    currentOrder: string;
    displayFilter: boolean;
    onSearch: EventEmitter<BaseFilter>;
    onReset: EventEmitter<BaseFilter>;
    constructor();
    abstract createNewFilter(): BaseFilter;
    submit(value?: string): void;
    fillFilterWithFormValues(): void;
    resetFilter(): boolean;
    resetForm(): void;
    postResetFilter(): void;
    changeOrder(newOrder: FilterOrder): void;
    get diagnostic(): string;
    static ɵfac: i0.ɵɵFactoryDef<BaseFilterComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<BaseFilterComponent, never, never, { "displayFilter": "displayFilter"; }, { "onSearch": "onSearch"; "onReset": "onReset"; }, never>;
}
export declare class FilterOrder {
    value: string;
    label: string;
    order: string[];
    constructor(value: string, label: string, order: string[]);
}
