import { Subject } from "rxjs";
import { PageStatus } from "../../shared/global.constants";
import { MessageService } from "../../shared/service/message.service";
import { ToolbarService } from "../../shared/service/toolbar.service";
import * as i0 from "@angular/core";
/**
 * Clase base mínima para cualquier componente.
 * @version 2.0
 */
export declare abstract class BaseComponent {
    protected toolbarService: ToolbarService;
    protected messageService: MessageService;
    status: PageStatus;
    componentId: string;
    toolbar: any;
    destroy$: Subject<boolean>;
    constructor(messageService: MessageService, toolbarService?: ToolbarService, componentId?: string);
    ngOnDestroy(): void;
    resetData(): void;
    updateToolbar(): void;
    converToDate(fecha: string): Date;
    static ɵfac: i0.ɵɵFactoryDef<BaseComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<BaseComponent, never, never, {}, {}, never>;
}
