"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseComponent = void 0;
var core_1 = require("@angular/core");
var rxjs_1 = require("rxjs");
var message_service_1 = require("../../shared/service/message.service");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var i0 = require("@angular/core");
var i1 = require("../../shared/service/message.service");
var i2 = require("../../shared/service/toolbar.service");
/**
 * Clase base mínima para cualquier componente.
 * @version 2.0
 */
var BaseComponent = /** @class */ (function () {
    function BaseComponent(messageService, toolbarService, componentId) {
        if (componentId === void 0) { componentId = "BASE"; }
        this.destroy$ = new rxjs_1.Subject();
        this.messageService = messageService;
        this.toolbarService = toolbarService;
        this.componentId = componentId;
        // console.log(`Soy el componente ${componentId}`);
    }
    BaseComponent.prototype.ngOnDestroy = function () {
        this.destroy$.next(true);
        this.destroy$.unsubscribe();
    };
    BaseComponent.prototype.resetData = function () {
        //this.errorMessage = '';
    };
    BaseComponent.prototype.updateToolbar = function () {
        // console.log(`invocación para updateToolbar del componente ${this.componentId}. Toolbar enviada:`);
        // console.log(this.toolbar);
        this.toolbarService && this.toolbarService.updateToolbar(this.componentId, this.toolbar);
    };
    BaseComponent.prototype.converToDate = function (fecha) {
        return new Date(fecha);
    };
    BaseComponent.ɵfac = function BaseComponent_Factory(t) { i0.ɵɵinvalidFactory(); };
    BaseComponent.ɵdir = i0.ɵɵdefineDirective({ type: BaseComponent });
    return BaseComponent;
}());
exports.BaseComponent = BaseComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BaseComponent, [{
        type: core_1.Directive
    }], function () { return [{ type: i1.MessageService }, { type: i2.ToolbarService }, { type: undefined }]; }, null); })();
//# sourceMappingURL=base.component.js.map