"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExceptionListFilterComponent = void 0;
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var log_exception_filter_1 = require("../shared/data/log-exception.filter");
var message_service_1 = require("../../shared/service/message.service");
var session_shared_service_1 = require("../../shared/service/session-shared.service");
var base_filter_component_1 = require("../../base/component/base-filter.component");
var base_filter_1 = require("../../base/shared/base.filter");
var custom_validators_service_1 = require("../../shared/service/custom-validators.service");
var i0 = require("@angular/core");
var i1 = require("@angular/forms");
var i2 = require("../../shared/service/message.service");
var i3 = require("../../shared/service/session-shared.service");
var i4 = require("../../shared/component/form/bit-date.component");
var i5 = require("../../shared/component/form/bit-time.component");
var i6 = require("../../shared/component/form/bit-text.component");
var ExceptionListFilterComponent = /** @class */ (function (_super) {
    __extends(ExceptionListFilterComponent, _super);
    function ExceptionListFilterComponent(formBuilder, messageService, sessionShared) {
        var _this = _super.call(this) || this;
        _this.formBuilder = formBuilder;
        _this.messageService = messageService;
        _this.sessionShared = sessionShared;
        //gestión del filtro
        _this.filter = _this.sessionShared.get("EXCEPTION_FILTER");
        if (_this.filter === undefined) {
            _this.filter = _this.createNewFilter();
            _this.filter.pagina = base_filter_1.BaseFilter.PAGE;
            _this.filter.resultados = base_filter_1.BaseFilter.RESULTADOS_PAGE;
            _this.sessionShared.set("EXCEPTION_FILTER", _this.filter);
        }
        //construimos el form
        _this.myForm = formBuilder.group({
            fecha: [_this.filter.fecha, [forms_1.Validators.required, custom_validators_service_1.CustomValidators.dataValidator]],
            desde: [_this.filter.desde, [forms_1.Validators.required]],
            hasta: [_this.filter.hasta, [forms_1.Validators.required]],
            login: [_this.filter.login]
        });
        return _this;
    }
    /** Crea un nuevo filtro para realizar la búsqueda */
    ExceptionListFilterComponent.prototype.createNewFilter = function () {
        return log_exception_filter_1.LogExceptionFilter.newObject();
    };
    ExceptionListFilterComponent.prototype.submit = function (value) {
        Object.assign(this.filter, this.myForm.value);
        _super.prototype.submit.call(this, value);
    };
    ExceptionListFilterComponent.ɵfac = function ExceptionListFilterComponent_Factory(t) { return new (t || ExceptionListFilterComponent)(i0.ɵɵdirectiveInject(i1.FormBuilder), i0.ɵɵdirectiveInject(i2.MessageService), i0.ɵɵdirectiveInject(i3.SessionSharedService)); };
    ExceptionListFilterComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ExceptionListFilterComponent, selectors: [["exception-list-filter"]], features: [i0.ɵɵInheritDefinitionFeature], decls: 28, vars: 6, consts: [[1, "panel", "panel-filtro", 3, "hidden"], [1, "panel-heading"], ["role", "form", 3, "formGroup", "submit"], [1, "panel-body"], [1, "row"], [1, "col-xs-3"], ["nombre", "fecha", 3, "control"], ["nombre", "desde", 3, "control"], ["nombre", "hasta", 3, "control"], ["nombre", "login", 3, "control"], [1, "panel-footer", "text-center"], ["role", "group", 1, "btn-group"], ["type", "reset", 1, "btn", "btn-default", 3, "click"], [1, "glyphicon", "glyphicon-erase"], ["type", "submit", 1, "btn", "btn-success"], [1, "glyphicon", "glyphicon-search"]], template: function ExceptionListFilterComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵelementStart(1, "div", 1);
            i0.ɵɵelement(2, "i");
            i0.ɵɵtext(3, "\u00A0\u00A0\u00A0Filtre de cerca ");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(4, "form", 2);
            i0.ɵɵlistener("submit", function ExceptionListFilterComponent_Template_form_submit_4_listener() { return ctx.submit(ctx.myForm.value); });
            i0.ɵɵelementStart(5, "div", 3);
            i0.ɵɵelementStart(6, "div", 4);
            i0.ɵɵelementStart(7, "div", 5);
            i0.ɵɵelementStart(8, "bit-date", 6);
            i0.ɵɵtext(9, "\u00A0\u00A0Data");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(10, "div", 5);
            i0.ɵɵelementStart(11, "bit-time", 7);
            i0.ɵɵtext(12, "\u00A0\u00A0Des de");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(13, "div", 5);
            i0.ɵɵelementStart(14, "bit-time", 8);
            i0.ɵɵtext(15, "\u00A0\u00A0Fins a");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(16, "div", 5);
            i0.ɵɵelementStart(17, "bit-text", 9);
            i0.ɵɵtext(18, "\u00A0\u00A0Login");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(19, "div", 10);
            i0.ɵɵelementStart(20, "div", 11);
            i0.ɵɵelementStart(21, "button", 12);
            i0.ɵɵlistener("click", function ExceptionListFilterComponent_Template_button_click_21_listener() { return ctx.resetFilter(); });
            i0.ɵɵtext(22, "Neteja\u00A0\u00A0");
            i0.ɵɵelement(23, "span", 13);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(24, "div", 11);
            i0.ɵɵelementStart(25, "button", 14);
            i0.ɵɵtext(26, "Cerca\u00A0\u00A0");
            i0.ɵɵelement(27, "span", 15);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("hidden", !ctx.displayFilter);
            i0.ɵɵadvance(4);
            i0.ɵɵproperty("formGroup", ctx.myForm);
            i0.ɵɵadvance(4);
            i0.ɵɵproperty("control", ctx.myForm.controls.fecha);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("control", ctx.myForm.controls.desde);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("control", ctx.myForm.controls.hasta);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("control", ctx.myForm.controls.login);
        } }, directives: [i1.ɵangular_packages_forms_forms_ba, i1.NgControlStatusGroup, i1.FormGroupDirective, i4.BitDateComponent, i5.BitTimeComponent, i6.BitTextComponent], encapsulation: 2 });
    return ExceptionListFilterComponent;
}(base_filter_component_1.BaseFilterComponent));
exports.ExceptionListFilterComponent = ExceptionListFilterComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ExceptionListFilterComponent, [{
        type: core_1.Component,
        args: [{
                selector: "exception-list-filter",
                template: "\n    <!-- Contenedor del filtro de búsqueda simple (siempre visible en pantalla) -->\n    <div class=\"panel panel-filtro\" [hidden]=\"!displayFilter\">\n        <div class=\"panel-heading\">\n            <i></i>&nbsp;&nbsp;&nbsp;Filtre de cerca\n        </div>\n        <form role=\"form\" [formGroup]=\"myForm\" (submit)=\"submit(myForm.value)\">\n            <div class=\"panel-body\">\n                <div class=\"row\">\n                    <div class=\"col-xs-3\">\n                        <bit-date nombre=\"fecha\" [control]=\"myForm.controls.fecha\">&nbsp;&nbsp;Data</bit-date>\n                    </div> \n                    <div class=\"col-xs-3\">\n                        <bit-time nombre=\"desde\" [control]=\"myForm.controls.desde\">&nbsp;&nbsp;Des de</bit-time>\n                    </div>\n                    <div class=\"col-xs-3\">\n                        <bit-time nombre=\"hasta\" [control]=\"myForm.controls.hasta\">&nbsp;&nbsp;Fins a</bit-time>\n                    </div>\n                    <div class=\"col-xs-3\">\n                        <bit-text nombre=\"login\" [control]=\"myForm.controls.login\">&nbsp;&nbsp;Login</bit-text>\n                    </div>\n                </div>\n            </div>\n            <div class=\"panel-footer text-center\">\n                <div class=\"btn-group\" role=\"group\">\n                    <button type=\"reset\" (click)=\"resetFilter()\" class=\"btn btn-default\">Neteja&nbsp;&nbsp;<span class=\"glyphicon glyphicon-erase\"></span></button>\n                </div>\n                <div class=\"btn-group\" role=\"group\">\n                    <button type=\"submit\" class=\"btn btn-success\">Cerca&nbsp;&nbsp;<span class=\"glyphicon glyphicon-search\"></span></button>\n                </div>\n            </div>\n        </form>\n    </div>\n  "
            }]
    }], function () { return [{ type: i1.FormBuilder }, { type: i2.MessageService }, { type: i3.SessionSharedService }]; }, null); })();
//# sourceMappingURL=exception-list-filter.component.js.map