"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExceptionListComponent = void 0;
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var exception_list_filter_component_1 = require("./exception-list-filter.component");
var developer_service_1 = require("../shared/service/developer.service");
var message_service_1 = require("../../shared/service/message.service");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var base_list_component_1 = require("../../base/component/base-list.component");
var i0 = require("@angular/core");
var i1 = require("../shared/service/developer.service");
var i2 = require("../../shared/service/message.service");
var i3 = require("../../shared/service/toolbar.service");
var i4 = require("@angular/router");
var i5 = require("../../shared/component/bit-header.component");
var i6 = require("./exception-list-filter.component");
var i7 = require("./exception-list-tableview.component");
var i8 = require("../../shared/component/bit-footer.component");
/**
 * Componente que implementa el listado de errores de aplicación para auditoría.
 * Permite consultar las exception que se han producido en la App.
 **/
var ExceptionListComponent = /** @class */ (function (_super) {
    __extends(ExceptionListComponent, _super);
    function ExceptionListComponent(developerService, messageService, toolbarService, activatedRoute, router) {
        var _this = _super.call(this, developerService, messageService, activatedRoute, router) || this;
        _this.developerService = developerService;
        _this.messageService = messageService;
        _this.toolbarService = toolbarService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.breadcrumb.push({ label: "Developer" });
        _this.breadcrumb.push({ label: "Exceptions" });
        return _this;
    }
    /** Tenemos que ver si activamos la autobúsqueda entre otras cosas */
    ExceptionListComponent.prototype.ngOnInit = function () {
        _super.prototype.init.call(this, this.exceptionListFilterComponent.filter);
    };
    /** Preparampos los datos antes de enviarlos al servidor */
    ExceptionListComponent.prototype.prepareDataForSubmit = function () {
        // nothing to do
    };
    ExceptionListComponent.ɵfac = function ExceptionListComponent_Factory(t) { return new (t || ExceptionListComponent)(i0.ɵɵdirectiveInject(i1.DeveloperService), i0.ɵɵdirectiveInject(i2.MessageService), i0.ɵɵdirectiveInject(i3.ToolbarService), i0.ɵɵdirectiveInject(i4.ActivatedRoute), i0.ɵɵdirectiveInject(i4.Router)); };
    ExceptionListComponent.ɵcmp = i0.ɵɵdefineComponent({ type: ExceptionListComponent, selectors: [["exception-list"]], viewQuery: function ExceptionListComponent_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuery(exception_list_filter_component_1.ExceptionListFilterComponent, 3);
        } if (rf & 2) {
            var _t = void 0;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.exceptionListFilterComponent = _t.first);
        } }, features: [i0.ɵɵInheritDefinitionFeature], decls: 4, vars: 7, consts: [[3, "breadcrumb", "onToolbarButtonPressed"], [3, "displayFilter", "onSearch", "onReset"], [3, "items"], ["type", "list", 3, "autoQueryObs", "totalItems", "status", "paginator", "onPageChange", "onNewPageSize"]], template: function ExceptionListComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "bit-header", 0);
            i0.ɵɵlistener("onToolbarButtonPressed", function ExceptionListComponent_Template_bit_header_onToolbarButtonPressed_0_listener($event) { return ctx.onToolbarButtonPressed($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(1, "exception-list-filter", 1);
            i0.ɵɵlistener("onSearch", function ExceptionListComponent_Template_exception_list_filter_onSearch_1_listener($event) { return ctx.onSearch($event); })("onReset", function ExceptionListComponent_Template_exception_list_filter_onReset_1_listener($event) { return ctx.onReset($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelement(2, "exception-list-tableview", 2);
            i0.ɵɵelementStart(3, "bit-footer", 3);
            i0.ɵɵlistener("onPageChange", function ExceptionListComponent_Template_bit_footer_onPageChange_3_listener($event) { return ctx.onPageChange($event); })("onNewPageSize", function ExceptionListComponent_Template_bit_footer_onNewPageSize_3_listener($event) { return ctx.onNewPageSize($event); });
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("breadcrumb", ctx.breadcrumb);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("displayFilter", true);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("items", ctx.items);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("autoQueryObs", ctx.autoQuerySubject.asObservable())("totalItems", ctx.totalItems)("status", ctx.status)("paginator", true);
        } }, directives: [i5.BitHeaderComponent, i6.ExceptionListFilterComponent, i7.ExceptionListTableViewComponent, i8.BitFooterComponent], encapsulation: 2 });
    return ExceptionListComponent;
}(base_list_component_1.BaseListComponent));
exports.ExceptionListComponent = ExceptionListComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(ExceptionListComponent, [{
        type: core_1.Component,
        args: [{
                selector: "exception-list",
                template: "\n    <bit-header [breadcrumb]=\"breadcrumb\" (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n    <exception-list-filter\n      [displayFilter]=\"true\"\n      (onSearch)=\"onSearch($event)\"\n      (onReset)=\"onReset($event)\"\n    ></exception-list-filter>\n    <exception-list-tableview [items]=\"items\"></exception-list-tableview>\n    <bit-footer\n      [autoQueryObs]=\"autoQuerySubject.asObservable()\"\n      [totalItems]=\"totalItems\"\n      [status]=\"status\"\n      type=\"list\"\n      [paginator]=\"true\"\n      (onPageChange)=\"onPageChange($event)\"\n      (onNewPageSize)=\"onNewPageSize($event)\"\n    ></bit-footer>\n  "
            }]
    }], function () { return [{ type: i1.DeveloperService }, { type: i2.MessageService }, { type: i3.ToolbarService }, { type: i4.ActivatedRoute }, { type: i4.Router }]; }, { exceptionListFilterComponent: [{
            type: core_1.ViewChild,
            args: [exception_list_filter_component_1.ExceptionListFilterComponent, { static: true }]
        }] }); })();
//# sourceMappingURL=exception-list.component.js.map