import { OnInit } from "@angular/core";
import { ActivatedRoute, Router } from "@angular/router";
import { LogService } from "../shared/service/log.service";
import { LogFilter } from "../shared/data/log.filter";
import { MessageService } from "../../shared/service/message.service";
import { BaseListComponent } from "../../base/component/base-list.component";
import * as i0 from "@angular/core";
/**
 * Componente que implementa el listado de log para auditoría.
 * Permite consultar todas las acciones que han realizad o los usuarios en la aplicación.
 **/
export declare class LogListNadaComponent extends BaseListComponent implements OnInit {
    protected logService: LogService;
    protected messageService: MessageService;
    protected activatedRoute: ActivatedRoute;
    protected route: Router;
    protected filter: LogFilter;
    constructor(logService: LogService, messageService: MessageService, activatedRoute: ActivatedRoute, route: Router);
    /** Construimos un filtro manual, desactivamos el botón de filtro del toolbar y buscamos al menos 500 elementos */
    ngOnInit(): any;
    /** Preparampos los datos antes de enviarlos al servidor */
    prepareDataForSubmit(): void;
    static ɵfac: i0.ɵɵFactoryDef<LogListNadaComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<LogListNadaComponent, "log-list", never, {}, {}, never, never>;
}
