"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogListNoFiltroComponent = void 0;
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var log_service_1 = require("../shared/service/log.service");
var log_filter_1 = require("../shared/data/log.filter");
var message_service_1 = require("../../shared/service/message.service");
var base_list_component_1 = require("../../base/component/base-list.component");
var i0 = require("@angular/core");
var i1 = require("../shared/service/log.service");
var i2 = require("../../shared/service/message.service");
var i3 = require("@angular/router");
var i4 = require("../../shared/component/bit-header.component");
var i5 = require("./log-list-tableview.component");
var i6 = require("../../shared/component/bit-footer.component");
/**
 * Componente que implementa el listado de log para auditoría.
 * Permite consultar todas las acciones que han realizad o los usuarios en la aplicación.
 **/
var LogListNoFiltroComponent = /** @class */ (function (_super) {
    __extends(LogListNoFiltroComponent, _super);
    function LogListNoFiltroComponent(logService, messageService, activatedRoute, router) {
        var _this = _super.call(this, logService, messageService, activatedRoute, router) || this;
        _this.logService = logService;
        _this.messageService = messageService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        return _this;
    }
    /** Construimos un filtro manual, desactivamos el botón de filtro del toolbar y buscamos 50 elementos sin paginación*/
    LogListNoFiltroComponent.prototype.ngOnInit = function () {
        this.filter = new log_filter_1.LogFilter("", "", "", "", null, false, 50, 1);
        this.toolbar["filter"].visible = false;
        this.search();
    };
    /** Preparampos los datos antes de enviarlos al servidor */
    LogListNoFiltroComponent.prototype.prepareDataForSubmit = function () {
        // nothing to do
    };
    LogListNoFiltroComponent.ɵfac = function LogListNoFiltroComponent_Factory(t) { return new (t || LogListNoFiltroComponent)(i0.ɵɵdirectiveInject(i1.LogService), i0.ɵɵdirectiveInject(i2.MessageService), i0.ɵɵdirectiveInject(i3.ActivatedRoute), i0.ɵɵdirectiveInject(i3.Router)); };
    LogListNoFiltroComponent.ɵcmp = i0.ɵɵdefineComponent({ type: LogListNoFiltroComponent, selectors: [["log-list"]], features: [i0.ɵɵInheritDefinitionFeature], decls: 3, vars: 5, consts: [[3, "toolbar", "onToolbarButtonPressed"], [3, "items"], [3, "autoQueryObs", "totalItems", "status"]], template: function LogListNoFiltroComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "bit-header", 0);
            i0.ɵɵlistener("onToolbarButtonPressed", function LogListNoFiltroComponent_Template_bit_header_onToolbarButtonPressed_0_listener($event) { return ctx.onToolbarButtonPressed($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelement(1, "log-list-tableview", 1);
            i0.ɵɵelement(2, "bit-footer", 2);
        } if (rf & 2) {
            i0.ɵɵproperty("toolbar", ctx.toolbar);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("items", ctx.items);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("autoQueryObs", ctx.autoQuerySubject.asObservable())("totalItems", ctx.totalItems)("status", ctx.status);
        } }, directives: [i4.BitHeaderComponent, i5.LogListTableViewComponent, i6.BitFooterComponent], encapsulation: 2 });
    return LogListNoFiltroComponent;
}(base_list_component_1.BaseListComponent));
exports.LogListNoFiltroComponent = LogListNoFiltroComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LogListNoFiltroComponent, [{
        type: core_1.Component,
        args: [{
                selector: "log-list",
                template: "\n    <bit-header [toolbar]=\"toolbar\" (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n    <log-list-tableview [items]=\"items\"></log-list-tableview>\n    <bit-footer\n      [autoQueryObs]=\"autoQuerySubject.asObservable()\"\n      [totalItems]=\"totalItems\"\n      [status]=\"status\"\n    ></bit-footer>\n  "
            }]
    }], function () { return [{ type: i1.LogService }, { type: i2.MessageService }, { type: i3.ActivatedRoute }, { type: i3.Router }]; }, null); })();
//# sourceMappingURL=log-list-nofiltro.component.js.map