"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogListComponent = void 0;
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var log_list_filter_component_1 = require("./log-list-filter.component");
var log_service_1 = require("../shared/service/log.service");
var message_service_1 = require("../../shared/service/message.service");
var toolbar_service_1 = require("../../shared/service/toolbar.service");
var base_list_component_1 = require("../../base/component/base-list.component");
var i0 = require("@angular/core");
var i1 = require("../shared/service/log.service");
var i2 = require("../../shared/service/message.service");
var i3 = require("@angular/router");
var i4 = require("../../shared/service/toolbar.service");
var i5 = require("../../shared/component/bit-header.component");
var i6 = require("./log-list-filter.component");
var i7 = require("./log-list-tableview.component");
var i8 = require("../../shared/component/bit-footer.component");
/**
 * Componente que implementa el listado de log para auditoría.
 * Permite consultar todas las acciones que han realizad o los usuarios en la aplicación.
 **/
var LogListComponent = /** @class */ (function (_super) {
    __extends(LogListComponent, _super);
    function LogListComponent(logService, messageService, activatedRoute, router, toolbarService) {
        var _this = _super.call(this, logService, messageService, activatedRoute, router, toolbarService) || this;
        _this.logService = logService;
        _this.messageService = messageService;
        _this.activatedRoute = activatedRoute;
        _this.router = router;
        _this.toolbarService = toolbarService;
        _this.breadcrumb.push({ label: "Desenvolupament", url: "developer/exceptions" }); //es un ejemplo
        _this.breadcrumb.push({ label: "Log" });
        return _this;
    }
    /** Tenemos que ver si activamos la autobúsqueda entre otras cosas. Pasamos el objeto filtro de nuestro hijo para realizar esa
     * hipotética autobúsqueda
     */
    LogListComponent.prototype.ngOnInit = function () {
        _super.prototype.init.call(this, this.logListFilterComponent.filter);
    };
    /** Preparampos los datos antes de enviarlos al servidor */
    LogListComponent.prototype.prepareDataForSubmit = function () {
        // nothing to do
    };
    LogListComponent.ɵfac = function LogListComponent_Factory(t) { return new (t || LogListComponent)(i0.ɵɵdirectiveInject(i1.LogService), i0.ɵɵdirectiveInject(i2.MessageService), i0.ɵɵdirectiveInject(i3.ActivatedRoute), i0.ɵɵdirectiveInject(i3.Router), i0.ɵɵdirectiveInject(i4.ToolbarService)); };
    LogListComponent.ɵcmp = i0.ɵɵdefineComponent({ type: LogListComponent, selectors: [["log-list"]], viewQuery: function LogListComponent_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuery(log_list_filter_component_1.LogListFilterComponent, 3);
        } if (rf & 2) {
            var _t = void 0;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.logListFilterComponent = _t.first);
        } }, features: [i0.ɵɵInheritDefinitionFeature], decls: 4, vars: 7, consts: [[3, "breadcrumb", "onToolbarButtonPressed"], [3, "displayFilter", "onSearch", "onReset"], [3, "items"], ["type", "list", 3, "autoQueryObs", "totalItems", "status", "paginator", "onPageChange", "onNewPageSize"]], template: function LogListComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "bit-header", 0);
            i0.ɵɵlistener("onToolbarButtonPressed", function LogListComponent_Template_bit_header_onToolbarButtonPressed_0_listener($event) { return ctx.onToolbarButtonPressed($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(1, "log-list-filter", 1);
            i0.ɵɵlistener("onSearch", function LogListComponent_Template_log_list_filter_onSearch_1_listener($event) { return ctx.onSearch($event); })("onReset", function LogListComponent_Template_log_list_filter_onReset_1_listener($event) { return ctx.onReset($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelement(2, "log-list-tableview", 2);
            i0.ɵɵelementStart(3, "bit-footer", 3);
            i0.ɵɵlistener("onPageChange", function LogListComponent_Template_bit_footer_onPageChange_3_listener($event) { return ctx.onPageChange($event); })("onNewPageSize", function LogListComponent_Template_bit_footer_onNewPageSize_3_listener($event) { return ctx.onNewPageSize($event); });
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("breadcrumb", ctx.breadcrumb);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("displayFilter", true);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("items", ctx.items);
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("autoQueryObs", ctx.autoQuerySubject.asObservable())("totalItems", ctx.totalItems)("status", ctx.status)("paginator", true);
        } }, directives: [i5.BitHeaderComponent, i6.LogListFilterComponent, i7.LogListTableViewComponent, i8.BitFooterComponent], encapsulation: 2 });
    return LogListComponent;
}(base_list_component_1.BaseListComponent));
exports.LogListComponent = LogListComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(LogListComponent, [{
        type: core_1.Component,
        args: [{
                selector: "log-list",
                template: "\n    <bit-header [breadcrumb]=\"breadcrumb\" (onToolbarButtonPressed)=\"onToolbarButtonPressed($event)\"></bit-header>\n    <log-list-filter [displayFilter]=\"true\" (onSearch)=\"onSearch($event)\" (onReset)=\"onReset($event)\"></log-list-filter>\n    <log-list-tableview [items]=\"items\"></log-list-tableview>\n    <bit-footer\n      [autoQueryObs]=\"autoQuerySubject.asObservable()\"\n      [totalItems]=\"totalItems\"\n      [status]=\"status\"\n      type=\"list\"\n      [paginator]=\"true\"\n      (onPageChange)=\"onPageChange($event)\"\n      (onNewPageSize)=\"onNewPageSize($event)\"\n    ></bit-footer>\n  "
            }]
    }], function () { return [{ type: i1.LogService }, { type: i2.MessageService }, { type: i3.ActivatedRoute }, { type: i3.Router }, { type: i4.ToolbarService }]; }, { logListFilterComponent: [{
            type: core_1.ViewChild,
            args: [log_list_filter_component_1.LogListFilterComponent, { static: true }]
        }] }); })();
//# sourceMappingURL=log-list.component.js.map