import { Observable } from "rxjs";
import { HttpUtilsService } from "../../../shared/service/http-utils.service";
import { MessageService } from "../../../shared/service/message.service";
import { BaseCRUDService } from "../../../base/shared/base.service";
import { HQL } from "../data/hql";
import { LogExceptionFilter } from "../data/log-exception.filter";
import * as i0 from "@angular/core";
export declare class DeveloperService extends BaseCRUDService {
    protected messageService: MessageService;
    protected http: HttpUtilsService;
    protected baseUrl: string;
    private hqlUrl;
    private sqlUrl;
    private hqlExecuteUrl;
    private sqlExecuteUrl;
    private hqlSimulateUrl;
    private sqlSimulateUrl;
    private countAllExceptionsByFilterUrl;
    private getAllExceptionsByFilterUrl;
    constructor(messageService: MessageService, http: HttpUtilsService);
    sendSHQL(esHQL: boolean, hqlRequest: HQL, execute: boolean, simulate: boolean): Observable<any>;
    getAllByFilter<T>(logFilter: LogExceptionFilter): Observable<T>;
    countAllByFilter(logFilter: LogExceptionFilter): Observable<number>;
    static ɵfac: i0.ɵɵFactoryDef<DeveloperService, never>;
    static ɵprov: i0.ɵɵInjectableDef<DeveloperService>;
}
