"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UploadComponent = void 0;
var core_1 = require("@angular/core");
var upload_service_1 = require("../../shared/service/upload.service");
var message_service_1 = require("../../shared/service/message.service");
var bitmessage_1 = require("../../shared/data/bitmessage");
var i0 = require("@angular/core");
var i1 = require("../../shared/service/upload.service");
var i2 = require("../../shared/service/message.service");
var i3 = require("@angular/forms");
var i4 = require("../../shared/component/bit-upload.component");
var UploadComponent = /** @class */ (function () {
    function UploadComponent(uploadService, messageService) {
        this.uploadService = uploadService;
        this.messageService = messageService;
    }
    UploadComponent.prototype.fileChange = function (files) {
        this.filesToUpload = files;
    };
    UploadComponent.prototype.submit = function () {
        var _this = this;
        this.uploadService.upload(null, this.filesToUpload, {}).then(function (result) {
            console.log(result);
            _this.messageService.sendNotification(new bitmessage_1.BitMessage("Informació", result));
        }, function (error) {
            console.log(error);
            var objError = JSON.parse(error);
            _this.messageService.sendNotification(new bitmessage_1.BitMessage("Error", objError.text, undefined, undefined, undefined, bitmessage_1.BitMessage.ERROR));
        });
    };
    Object.defineProperty(UploadComponent.prototype, "noFiles", {
        get: function () {
            return this.filesToUpload == null || (this.filesToUpload != null && this.filesToUpload.length == 0);
        },
        enumerable: false,
        configurable: true
    });
    UploadComponent.ɵfac = function UploadComponent_Factory(t) { return new (t || UploadComponent)(i0.ɵɵdirectiveInject(i1.UploadService), i0.ɵɵdirectiveInject(i2.MessageService)); };
    UploadComponent.ɵcmp = i0.ɵɵdefineComponent({ type: UploadComponent, selectors: [["upload"]], decls: 23, vars: 2, consts: [[1, "container"], [1, "row", "cotainer-bread-btn"], [1, "col-xs-6"], [1, "breadcrumb"], [1, "active"], [1, "row"], [1, "col-xs-12"], ["method", "post", "enctype", "multipart/form-data", 3, "submit"], [1, "form-group"], [1, "seccion"], [1, "row", "separador"], [3, "showFiles", "onFileChange"], [1, "col-xs-12", "text-center"], ["type", "submit", 1, "btn", "btn-default", 3, "disabled"], [1, "glyphicon", "glyphicon-cloud-upload"]], template: function UploadComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵelementStart(1, "div", 1);
            i0.ɵɵelementStart(2, "div", 2);
            i0.ɵɵelementStart(3, "ol", 3);
            i0.ɵɵelementStart(4, "li");
            i0.ɵɵtext(5, "Upload");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(6, "li", 4);
            i0.ɵɵtext(7, "Pujada de fitxers");
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelement(8, "div", 2);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(9, "div", 5);
            i0.ɵɵelementStart(10, "div", 6);
            i0.ɵɵelementStart(11, "form", 7);
            i0.ɵɵlistener("submit", function UploadComponent_Template_form_submit_11_listener() { return ctx.submit(); });
            i0.ɵɵelementStart(12, "div", 8);
            i0.ɵɵelementStart(13, "h4", 9);
            i0.ɵɵtext(14, "Multiple upload");
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(15, "div", 10);
            i0.ɵɵelementStart(16, "div", 6);
            i0.ɵɵelementStart(17, "bit-upload", 11);
            i0.ɵɵlistener("onFileChange", function UploadComponent_Template_bit_upload_onFileChange_17_listener($event) { return ctx.fileChange($event); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(18, "div", 10);
            i0.ɵɵelementStart(19, "div", 12);
            i0.ɵɵelementStart(20, "button", 13);
            i0.ɵɵtext(21, "Upload\u00A0\u00A0");
            i0.ɵɵelement(22, "span", 14);
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵadvance(17);
            i0.ɵɵproperty("showFiles", true);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("disabled", ctx.noFiles);
        } }, directives: [i3.ɵangular_packages_forms_forms_ba, i3.NgControlStatusGroup, i3.NgForm, i4.BitUploadComponent], encapsulation: 2 });
    return UploadComponent;
}());
exports.UploadComponent = UploadComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(UploadComponent, [{
        type: core_1.Component,
        args: [{
                selector: "upload",
                template: "\n    <div class=\"container\">\n        <div class=\"row cotainer-bread-btn\">\n          <div class=\"col-xs-6\">\n            <!-- ruta de donde nos encontramos (miga de pan) -->\n            <ol class=\"breadcrumb\">\n              <li>Upload</li>\n              <li class=\"active\">Pujada de fitxers</li>\n            </ol>\n          </div>\n          <div class=\"col-xs-6\">\n            <!-- botnera de acciones -->\n\n        \n          </div>\n        </div>\n    </div>\n    <div class=\"row\">\n        <div class=\"col-xs-12\">\n            <form method=\"post\" enctype=\"multipart/form-data\" (submit)=\"submit()\">\n                <div class=\"form-group\" >\n                    <h4 class=\"seccion\">Multiple upload</h4>\n                    <div class=\"row separador\">\n                        <div class=\"col-xs-12\">\n                          <bit-upload (onFileChange)=\"fileChange($event)\" [showFiles]=true></bit-upload>\n                        </div>\n                    </div>\n                    <div class=\"row separador\">\n                        <div class=\"col-xs-12 text-center\">\n                            <button type=\"submit\" [disabled]=\"noFiles\" class=\"btn btn-default\">Upload&nbsp;&nbsp;<span class=\"glyphicon glyphicon-cloud-upload\"></span></button>\n                        </div>\n                    </div> \n                </div>\n            </form>\n        </div>\n    </div>\n  "
            }]
    }], function () { return [{ type: i1.UploadService }, { type: i2.MessageService }]; }, null); })();
//# sourceMappingURL=upload.component.js.map