import { OnInit, OnChanges, AfterViewInit, EventEmitter, SimpleChange } from "@angular/core";
import { Paginator } from "primeng/paginator";
import { Observable } from "rxjs";
import { PageStatus } from "../global.constants";
import { BaseFilter } from "../../base/shared/base.filter";
import * as i0 from "@angular/core";
/**
 * Componenente que muestra un paginador en la sección footer.
 **/
export declare class BitFooterComponent implements OnInit, OnChanges, AfterViewInit {
    static TYPE_LIST: string;
    static TYPE_FORM: string;
    static TYPE_BLANK: string;
    pc: Paginator;
    autoQueryObs: Observable<BaseFilter>;
    totalItems: number;
    paginator: boolean;
    mostrarAvisos: boolean;
    fixed: boolean;
    pageLinkSize: number;
    itemsPerPage: number;
    status: PageStatus;
    typeFooter: string;
    messages: Map<PageStatus, string>;
    onPageChange: EventEmitter<number>;
    onNewPageSize: EventEmitter<number>;
    baseItemsPerPage: number;
    ngOnInit(): void;
    /**
     * Cuando tengamos la referncia al componente paginator nos suscribimos al observable para recibir la notificación
     * de que se ha realizado una autobúsqueda con una página y/o resultados por página diferente al estándar
     */
    ngAfterViewInit(): void;
    /**
     * Escucharemos a cambios en las propiedades totalItems para actualizar el paginador con respecto a las páginas que mostramos
     */
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    /** Calcula el número de enlaces visibles en el paginador (en el rango entre 1 y 20). */
    calculatePageLinkSize(): void;
    /** Establece el número de página en la visualización de resultados. Se invoca cuando el usuario cambia el número de resultados a mostrar o cambia de página */
    paginate(event: any): void;
    getStyle(): "footer" | "footer navbar-fixed-bottom";
    /** Flag: la página está realizando la búsqueda. */
    get searchInitiated(): boolean;
    /** Flag: la página está realizando la búsqueda. */
    get searching(): boolean;
    /** Flag: la página ha finalizado la última búsqueda. */
    get searchFinished(): boolean;
    /** Flag: la página está en modo solo lectura */
    get readOnly(): boolean;
    /** Flag: la página ha finalizado con error */
    get error(): boolean;
    /** Flag: encontrado resultado. */
    get foundResult(): boolean;
    /** Flag: no hay resultados. */
    get emptyResult(): boolean;
    get initMessage(): string;
    get searchingMessage(): string;
    get finishMessage(): string;
    get readOnlyMessage(): string;
    static ɵfac: i0.ɵɵFactoryDef<BitFooterComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<BitFooterComponent, "bit-footer", never, { "autoQueryObs": "autoQueryObs"; "totalItems": "totalItems"; "paginator": "paginator"; "mostrarAvisos": "mostrarAvisos"; "fixed": "fixed"; "status": "status"; "typeFooter": "type"; "messages": "messages"; }, { "onPageChange": "onPageChange"; "onNewPageSize": "onNewPageSize"; }, never, never>;
}
