"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BitNotificationComponent = void 0;
var core_1 = require("@angular/core");
var message_service_1 = require("../service/message.service");
var api_1 = require("primeng/api");
var i0 = require("@angular/core");
var i1 = require("../service/message.service");
var i2 = require("primeng/api");
var i3 = require("primeng/toast");
var i4 = require("primeng/messages");
var BitNotificationComponent = /** @class */ (function () {
    function BitNotificationComponent(messageService, primeMessageService) {
        var _this = this;
        this.primeMessageService = primeMessageService;
        this.notificationMessages = [];
        this.errorMessages = [];
        //avisoService.initAvisosPedientes();  //hacer su propio componente que cargue los avisos
        //console.log("DialogComponent contructor(" + messageService  + ")");
        //Nos suscribimos a la espera de que envíen notificaciones
        this.subscriptionNotifications = messageService.observableNotifications.subscribe(function (message) {
            _this.showMessage(message);
        });
        //Nos suscribimos a la espera de que envíen notificaciones de error
        this.subscriptionNotificationsErrors = messageService.observableNotificationsErrors.subscribe(function (notificationError) {
            _this.showNotificationError(notificationError);
        });
    }
    BitNotificationComponent.prototype.showMessage = function (message) {
        // this.notificationMessages = [];
        // this.notificationMessages.push({ severity: message.severity, summary: message.title, detail: message.message });
        this.primeMessageService.add({
            key: "notification",
            severity: message.severity,
            summary: message.title,
            detail: message.message
        });
    };
    BitNotificationComponent.prototype.showNotificationError = function (notificationError) {
        this.errorMessages = [];
        if (notificationError.multipleText) {
            for (var _i = 0, _a = notificationError.multipleText; _i < _a.length; _i++) {
                var error = _a[_i];
                this.errorMessages.push({
                    severity: "error",
                    summary: notificationError.textCA || notificationError.text,
                    detail: error
                });
            }
        }
        else {
            this.errorMessages.push({
                severity: "error",
                summary: notificationError.textCA || notificationError.text,
                detail: notificationError.masInfo
            });
        }
    };
    BitNotificationComponent.prototype.ngOnDestroy = function () {
        // prevent memory leak when component destroyed
        this.notificationMessages = null;
        this.errorMessages = null;
        this.subscriptionNotifications.unsubscribe();
        this.subscriptionNotificationsErrors.unsubscribe();
    };
    BitNotificationComponent.MENSAJE_VOID = "No hi ha dades per mostrar";
    BitNotificationComponent.ɵfac = function BitNotificationComponent_Factory(t) { return new (t || BitNotificationComponent)(i0.ɵɵdirectiveInject(i1.MessageService), i0.ɵɵdirectiveInject(i2.MessageService)); };
    BitNotificationComponent.ɵcmp = i0.ɵɵdefineComponent({ type: BitNotificationComponent, selectors: [["bit-notification"]], decls: 2, vars: 2, consts: [["key", "notification", "position", "top-right"], [3, "value", "closable"]], template: function BitNotificationComponent_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelement(0, "p-toast", 0);
            i0.ɵɵelement(1, "p-messages", 1);
        } if (rf & 2) {
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("value", ctx.errorMessages)("closable", true);
        } }, directives: [i3.Toast, i4.Messages], encapsulation: 2 });
    return BitNotificationComponent;
}());
exports.BitNotificationComponent = BitNotificationComponent;
(function () { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(BitNotificationComponent, [{
        type: core_1.Component,
        args: [{
                selector: "bit-notification",
                template: "\n    <p-toast key=\"notification\" position=\"top-right\"></p-toast>\n    <p-messages [value]=\"errorMessages\" [closable]=\"true\"></p-messages>\n  "
            }]
    }], function () { return [{ type: i1.MessageService }, { type: i2.MessageService }]; }, null); })();
//# sourceMappingURL=bit-notification.component.js.map