import { ChangeDetectorRef } from "@angular/core";
import { ConfigurationEditor } from "../../data/configuration-editor";
import { BitCustomComponent } from "./bit-custom.component";
import { AyudaService } from "../../service/ayuda.service";
import * as i0 from "@angular/core";
export declare const CUSTOM_BITEDITOR_CONTROL_VALUE_ACCESSOR: any;
/**
 * Clase que utiliza un custom componente para campo editor de HTML
 * Utiliza la interfaz ControlValueAccessor
 *    <bit-editor [(ngModel)]="object.descripcion" [ngModelOptions]="{standalone: true}" height="250">&nbsp;&nbsp;Descripció</bit-editor>
 * Para utilizar, importar tambien js y css.
 *
 * https://www.primefaces.org/primeng/#/editor
 * https://quilljs.com/docs/modules/toolbar/
 *
 **/
export declare class BitEditorComponent extends BitCustomComponent {
    protected ayudaService: AyudaService;
    protected changeDetectorRef: ChangeDetectorRef;
    tipo: string;
    configuration: ConfigurationEditor;
    height: number;
    static globalConfiguration: ConfigurationEditor;
    constructor(ayudaService: AyudaService, changeDetectorRef: ChangeDetectorRef);
    get value_lectura(): string;
    onFocus(): void;
    onInit(quill: any): void;
    get configuracion(): ConfigurationEditor;
    static ɵfac: i0.ɵɵFactoryDef<BitEditorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDefWithMeta<BitEditorComponent, "bit-editor", never, { "tipo": "tipo"; "configuration": "configuration"; "height": "height"; }, {}, never, ["*"]>;
}
