import { EventEmitter, OnInit } from "@angular/core";
import { FormControl } from "@angular/forms";
import { AyudaService } from "../../service/ayuda.service";
import * as i0 from "@angular/core";
/**
 *  Clase general que todos los componentes personalizados deben extender. Contiene toda la lógica común para trabajar con
 * componentes personalizados
 */
export declare abstract class BitGeneralComponent implements OnInit {
    protected ayudaService: AyudaService;
    control: FormControl;
    nombre: any;
    nombreDirectiva: any;
    label: string;
    estilo: string;
    tooltipTexto: string;
    tooltipPosicion: string;
    ayuda: string;
    placeholder: string;
    readOnly: boolean;
    hideLabel: boolean;
    instanciaPipe: any;
    forceObligatorio: boolean;
    onChange: EventEmitter<string>;
    constructor(ayudaService: AyudaService);
    /** Debemos suscribirnos a los cambios del FormControl para emitir mediante onChange el evento con el nuevo valor que tiene el componente. */
    ngOnInit(): void;
    /** Controlamos si debemos modificar el valor interno del componente mediante una transformacion al tener un pipe asociado. */
    onBlur(): void;
    onFocus(): void;
    /**
     * Si es necesario, transformamos el valor de entrada para que se muestre correctamente en el campo (ver bit-dropdown-general).
     */
    protected transformValue(): void;
    get obligatorio(): boolean;
    showAyuda(): void;
    get value_lectura(): string;
    static ɵfac: i0.ɵɵFactoryDef<BitGeneralComponent, never>;
    static ɵdir: i0.ɵɵDirectiveDefWithMeta<BitGeneralComponent, never, never, { "control": "control"; "nombre": "nombre"; "nombreDirectiva": "nombreDirectiva"; "label": "label"; "estilo": "estilo"; "tooltipTexto": "tooltipTexto"; "tooltipPosicion": "tooltipPosicion"; "ayuda": "ayuda"; "placeholder": "placeholder"; "readOnly": "readOnly"; "hideLabel": "hideLabel"; "instanciaPipe": "instanciaPipe"; "forceObligatorio": "forceObligatorio"; }, { "onChange": "onChange"; }, never>;
}
