import { HttpClient, HttpErrorResponse } from "@angular/common/http";
import { Observable } from "rxjs";
import { Error as CustomError } from "../data/error";
import { MessageService } from "./message.service";
import { GeneralUtils } from "./general-utils.service";
import * as i0 from "@angular/core";
export declare class HttpUtilsService {
    http: HttpClient;
    messageService: MessageService;
    generalUtils: GeneralUtils;
    private apiUrl;
    private contextPath;
    static CONTEXT_PATH: string;
    static LOGIN_AUTHENTICATION: any;
    constructor(http: HttpClient, messageService: MessageService, generalUtils: GeneralUtils, apiUrl: string, contextPath: string);
    static getCustomError(error: HttpErrorResponse): CustomError;
    static reloadPage(): void;
    getHttpPost<T>(url: any, hqlRequest: any, emptyResponse?: boolean): Observable<T>;
    getHttpPut<T>(url: any, hqlRequest: any): Observable<T>;
    getHttpDelete(url: any): Observable<any>;
    getHttpGet<T>(url: any): Observable<T>;
    private addAuthenticationData;
    static ɵfac: i0.ɵɵFactoryDef<HttpUtilsService, never>;
    static ɵprov: i0.ɵɵInjectableDef<HttpUtilsService>;
}
export declare var httpUtilsServiceInjectables: Array<any>;
